<?php

/**
 * ownCloud - global_ldap
 *
 * @author Dominik Schmidt
 * @copyright 2011 Dominik Schmidt dev@dominik-schmidt.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU AFFERO GENERAL PUBLIC LICENSE
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU AFFERO GENERAL PUBLIC LICENSE for more details.
 *
 * You should have received a copy of the GNU Affero General Public
 * License along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
$params = array('enable_global_ldap_plugin', 'enable_global_ldap_plugin_for_group', 'ldap_host', 'ldap_port', 'ldap_dn', 'ldap_password', 'ldap_base', 'ldap_login_attr', 'ldap_user_filter', 'ldap_tls', 'ldap_nocase', 'ldap_quota', 'ldap_quota_def', 'ldap_email', 'ldap_group_display_attr', 'ldap_group_member_attr', 'ldap_group_filter', 'ldap_group_admin', 'ldap_group_member_attr_use_dn');


// fill template
$tmpl = new OC_Template('global_ldap', 'settings');
$tmpl->assign('ldap_test_std', 0);
$tmpl->assign('ldap_test_admin', 0);
$tmpl->assign('ldap_group_test_std_user', '');
$tmpl->assign('ldap_group_test_admin_user', '');

if ($_POST) {
    $ldap_group_test_std_user = $_POST['ldap_group_test_std_user'];
    unset($_POST['ldap_group_test_std_user']);
    $ldap_group_test_admin_user = $_POST['ldap_group_test_admin_user'];
    unset($_POST['ldap_group_test_admin_user']);

    foreach ($params as $param) {
        if (isset($_POST[$param])) {
            OC_Appconfig::setValue('global_ldap', $param, $_POST[$param]);
        } elseif ('ldap_tls' == $param) {
            // unchecked checkboxes are not included in the post paramters
            OC_Appconfig::setValue('global_ldap', $param, 0);
        } elseif ('ldap_nocase' == $param) {
            OC_Appconfig::setValue('global_ldap', $param, 0);
        } elseif ('enable_global_ldap_plugin' == $param) {
            OC_Appconfig::setValue('global_ldap', $param, 0);
        } elseif ('enable_global_ldap_plugin_for_group' == $param) {
            OC_Appconfig::setValue('global_ldap', $param, 0);
        } elseif ('ldap_group_member_attr_use_dn' == $param) {
            OC_Appconfig::setValue('global_ldap', $param, 0);
        }
    }

    $test_user = new OC_USER_GLDAP();
    $test_group = new OC_GROUP_GLDAP();

    if (!empty($ldap_group_test_std_user)) {
        $tmpl->assign('ldap_group_test_std_user', $ldap_group_test_std_user);

        if ($test_user->userExists($ldap_group_test_std_user) &&
                !$test_group->inGroup($ldap_group_test_std_user, $_POST['ldap_group_admin'])) {
            $tmpl->assign('ldap_test_std', 1);
        } else {
            $tmpl->assign('ldap_test_std', 2);
        }
    }

    if (!empty($ldap_group_test_admin_user)) {
        $tmpl->assign('ldap_group_test_admin_user', $ldap_group_test_admin_user);

        if ($test_user->userExists($ldap_group_test_admin_user) &&
                $test_group->inGroup($ldap_group_test_admin_user, $_POST['ldap_group_admin'])) {
            $tmpl->assign('ldap_test_admin', 1);
        } else {
            $tmpl->assign('ldap_test_admin', 2);
        }
    }
}

foreach ($params as $param) {
    $value = OC_Appconfig::getValue('global_ldap', $param, '');
    $tmpl->assign($param, $value);
}

// ldap_port has a default value
$tmpl->assign('ldap_port', OC_Appconfig::getValue('global_ldap', 'ldap_port', OC_USER_BACKEND_GLDAP_DEFAULT_PORT));

// ldap_login_attr has a default value
$tmpl->assign('ldap_login_attr', OC_Appconfig::getValue('global_ldap', 'ldap_login_attr', OC_USER_BACKEND_GLDAP_DEFAULT_LOGIN_ATTRIBUTE));

return $tmpl->fetchPage();
